/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package View;

import Controler.TelSeznamController;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;

/**
 *
 * @author User
 */
public class JFrameSearch extends javax.swing.JFrame {
    TelSeznamController telSeznamController;
    /**
     * Creates new form JFrameSearch
     */
    public JFrameSearch() {
        initComponents();
         try {
            telSeznamController = new TelSeznamController();
             
            
            ArrayList<String[]> rs = telSeznamController.getData();
            this.setTableModel(this.tabList, rs);             
            
            this.setVisible(true);
                        
        } catch (IOException ex) {
            System.err.println(ex.getMessage());
        } catch (ClassNotFoundException ex) {
            System.err.println(ex.getMessage());
        }
    }
    
    private void setTableModel(JTable jtable, ArrayList<String[]> rs){
        /*if(rs==null || rs.size()==0){
            return;
        }*/
        String[] columns = telSeznamController.getZahlavi();
        
        String[] values = new String[columns.length];
        String[][] modelValues = new String[rs.size()][columns.length];
        int i=0, j=0;
        
        for (String[] m : rs) {
            for (String o : m) {
                if (o==null) continue;
                 
                modelValues[i][j] = (String) o;
                j++;
            }
            i++;
            j=0;
        }
             
        TableModel tableModel = new DefaultTableModel(modelValues, columns);
        jtable.setModel(tableModel);   
        
        setColumnWidth(jtable, jtable.getColumnModel().getColumnIndex("jmeno"), 250);
        setColumnWidth(jtable, jtable.getColumnModel().getColumnIndex("funkce"), 250);
        setColumnInvisible(jtable, jtable.getColumnModel().getColumnIndex("popis cinnosti"));
        setColumnInvisible(jtable, jtable.getColumnModel().getColumnIndex("cislo dveri"));
        setColumnWidth(jtable, jtable.getColumnModel().getColumnIndex("telefon"), 100);
        setColumnWidth(jtable, jtable.getColumnModel().getColumnIndex("mobil"), 100);
        setColumnWidth(jtable, jtable.getColumnModel().getColumnIndex("email"), 250);
        setColumnInvisible(jtable, jtable.getColumnModel().getColumnIndex("oddeleni"));
        setColumnWidth(jtable, jtable.getColumnModel().getColumnIndex("zkratka odboru"), 100);
        setColumnInvisible(jtable, jtable.getColumnModel().getColumnIndex("nazev odboru"));

    }   
    
    private void setColumnInvisible(JTable jtable, int index){
        jtable.getColumnModel().getColumn(index).setMinWidth(0);
        jtable.getColumnModel().getColumn(index).setMaxWidth(0);
        jtable.getColumnModel().getColumn(index).setPreferredWidth(0);
        jtable.getColumnModel().getColumn(index).setWidth(0); 
    }

    private void setColumnWidth(JTable jtable, int index, int colWidth){
        jtable.getColumnModel().getColumn(index).setMinWidth(0);
        jtable.getColumnModel().getColumn(index).setMaxWidth(colWidth+250);
        jtable.getColumnModel().getColumn(index).setPreferredWidth(colWidth);
        jtable.getColumnModel().getColumn(index).setWidth(colWidth);  
    }  
    
      /**
       * Vypíše vydrany hodnoty do jTable
     
     */
       private void ShowResult(ArrayList<String[]> result){
            if(result.isEmpty()){
           
               tabList.setModel(new javax.swing.table.DefaultTableModel(
                    new Object [][] {  
                     {"Not found", null, null, null, null, null, null, null, null, null}                
                    }, telSeznamController.getZahlavi()));
                cmbOdbor.setSelectedIndex(-1); 
           } else {
                this.setTableModel(this.tabList, result);
                cmbOdbor.setSelectedIndex(-1); 
           }
     }
      /**
       * Kontrola inputu
     
     */
     private boolean checkInput(String input){
         
         boolean a=false;
         if("".equals(input)){
             a=true;
         }else
          if(input.matches("[\\sa-zA-ZÁÄÉĚÍÓÖÚŮÜÝŽŠČŘĎŤŇáäééěíóöůúüýžščřďťň]*")){
            a=true;
         }
    
         return a;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnSearch = new javax.swing.JButton();
        panelFilter = new javax.swing.JPanel();
        txtJmeno = new javax.swing.JTextField();
        lbJmeno = new javax.swing.JLabel();
        lbFunkce = new javax.swing.JLabel();
        lbTelefon = new javax.swing.JLabel();
        lbMobil = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        lbEmail = new javax.swing.JLabel();
        lbOdbor = new javax.swing.JLabel();
        txtFunkce = new javax.swing.JTextField();
        txtTelefon = new javax.swing.JTextField();
        txtMobil = new javax.swing.JTextField();
        txtEmail = new javax.swing.JTextField();
        chkCaseSensitive = new javax.swing.JCheckBox();
        chkDiacritics = new javax.swing.JCheckBox();
        cmbOdbor = new javax.swing.JComboBox<>();
        lbTip = new javax.swing.JLabel();
        panelList = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tabList = new javax.swing.JTable();
        btnClear = new javax.swing.JButton();
        btnAdd = new javax.swing.JButton();
        btnEdit = new javax.swing.JButton();
        btnRemove = new javax.swing.JButton();
        menuHlavniMenu = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        menuItemImport = new javax.swing.JMenuItem();
        menuItemExport = new javax.swing.JMenuItem();
        menuItemSave = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Telefonní seznam");

        btnSearch.setText("Search");
        btnSearch.setToolTipText("Výběr dat podle nastavených kritérií");
        btnSearch.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnSearchMouseClicked(evt);
            }
        });
        btnSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSearchActionPerformed(evt);
            }
        });

        panelFilter.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Filter", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N

        txtJmeno.setToolTipText("Zadej jméno");

        lbJmeno.setText("Jméno:");

        lbFunkce.setText("Funkce:");

        lbTelefon.setText("Telefon:");

        lbMobil.setText("Mobil:");

        jLabel4.setText("jLabel4");

        lbEmail.setText("e-mail:");

        lbOdbor.setText("Odbor:");

        txtFunkce.setToolTipText("Zadej funkci");
        txtFunkce.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtFunkceActionPerformed(evt);
            }
        });

        txtTelefon.setToolTipText("Zadej telefon");

        txtMobil.setToolTipText("Zadej mobil");
        txtMobil.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtMobilActionPerformed(evt);
            }
        });

        txtEmail.setToolTipText("Zadej e-mail");

        chkCaseSensitive.setSelected(true);
        chkCaseSensitive.setText("Rozlišovat malá/velká písmena");
        chkCaseSensitive.setToolTipText("Nastav case sensitive");

        chkDiacritics.setSelected(true);
        chkDiacritics.setText("Zohledňovat diakritiku");
        chkDiacritics.setToolTipText("nastav zohledňování diakritiky");

        cmbOdbor.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "DS", "EK", "INV", "KH", "KR", "RG", "SM", "SNKHK", "SV", "UP", "VAVFK", "VZ", "ZD", "ZP", "^$", "^.+$" }));
        cmbOdbor.setSelectedIndex(-1);
        cmbOdbor.setToolTipText("Zadej zkratku odboru");

        lbTip.setFont(new java.awt.Font("Tahoma", 2, 11)); // NOI18N
        lbTip.setForeground(new java.awt.Color(0, 0, 255));
        lbTip.setIcon(new javax.swing.ImageIcon("C:\\Users\\sukovi\\Documents\\NetBeansProjects\\blablabla\\JavaApplication3\\Tips-icon.png")); // NOI18N
        lbTip.setText("Tip: Při vyhledávání lze použít zástupný znak % nebo regulární výraz");

        javax.swing.GroupLayout panelFilterLayout = new javax.swing.GroupLayout(panelFilter);
        panelFilter.setLayout(panelFilterLayout);
        panelFilterLayout.setHorizontalGroup(
            panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelFilterLayout.createSequentialGroup()
                .addGroup(panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelFilterLayout.createSequentialGroup()
                        .addGroup(panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(panelFilterLayout.createSequentialGroup()
                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(lbMobil))
                            .addGroup(panelFilterLayout.createSequentialGroup()
                                .addGap(18, 18, 18)
                                .addGroup(panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(lbFunkce)
                                    .addComponent(lbOdbor)
                                    .addComponent(lbJmeno))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addGroup(panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(txtJmeno, javax.swing.GroupLayout.PREFERRED_SIZE, 287, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(txtFunkce, javax.swing.GroupLayout.PREFERRED_SIZE, 287, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(cmbOdbor, javax.swing.GroupLayout.PREFERRED_SIZE, 164, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 37, Short.MAX_VALUE)
                                .addGroup(panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(lbEmail, javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(lbTelefon, javax.swing.GroupLayout.Alignment.TRAILING))))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtEmail, javax.swing.GroupLayout.PREFERRED_SIZE, 324, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtTelefon, javax.swing.GroupLayout.PREFERRED_SIZE, 221, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtMobil, javax.swing.GroupLayout.PREFERRED_SIZE, 221, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(panelFilterLayout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(lbTip, javax.swing.GroupLayout.PREFERRED_SIZE, 605, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGroup(panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelFilterLayout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addGap(39, 39, 39))
                    .addGroup(panelFilterLayout.createSequentialGroup()
                        .addGap(49, 49, 49)
                        .addGroup(panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(chkCaseSensitive)
                            .addComponent(chkDiacritics))
                        .addContainerGap(46, Short.MAX_VALUE))))
        );

        panelFilterLayout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {txtFunkce, txtJmeno});

        panelFilterLayout.setVerticalGroup(
            panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelFilterLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lbTip)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lbJmeno)
                    .addComponent(txtJmeno, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txtTelefon, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lbTelefon))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lbFunkce)
                    .addComponent(txtFunkce, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txtMobil, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lbMobil)
                    .addComponent(chkCaseSensitive))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelFilterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                        .addComponent(lbOdbor)
                        .addComponent(cmbOdbor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(lbEmail)
                        .addComponent(txtEmail, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(chkDiacritics))
                .addGap(41, 41, 41))
            .addGroup(panelFilterLayout.createSequentialGroup()
                .addGap(43, 43, 43)
                .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 0, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        panelFilterLayout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {cmbOdbor, txtEmail, txtFunkce, txtJmeno, txtMobil, txtTelefon});

        panelFilterLayout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {lbFunkce, lbJmeno, lbOdbor, lbTip});

        panelList.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "List", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N

        tabList.setAutoCreateRowSorter(true);
        tabList.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null}
            },
            new String [] {
                "jmeno", "funkce", "popis cinnosti", "cislo dveri", "telefon", "mobil", "email", "oddeleni", "zkratka odboru", "nazev odboru"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tabList.setMaximumSize(new java.awt.Dimension(2147483647, 140));
        jScrollPane1.setViewportView(tabList);

        javax.swing.GroupLayout panelListLayout = new javax.swing.GroupLayout(panelList);
        panelList.setLayout(panelListLayout);
        panelListLayout.setHorizontalGroup(
            panelListLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelListLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 1013, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        panelListLayout.setVerticalGroup(
            panelListLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelListLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 317, Short.MAX_VALUE))
        );

        btnClear.setText("Clear");
        btnClear.setToolTipText("Vyčištění filtru");
        btnClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnClearActionPerformed(evt);
            }
        });

        btnAdd.setText("Add");
        btnAdd.setToolTipText("Přidání záznamu");

        btnEdit.setText("Edit");
        btnEdit.setToolTipText("Změna záznamu");

        btnRemove.setText("Remove");
        btnRemove.setToolTipText("Odstranění záznamu");

        jMenu1.setText("Data");

        menuItemImport.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_I, java.awt.event.InputEvent.CTRL_MASK));
        menuItemImport.setText("Import CSV");
        menuItemImport.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItemImportActionPerformed(evt);
            }
        });
        jMenu1.add(menuItemImport);

        menuItemExport.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_E, java.awt.event.InputEvent.CTRL_MASK));
        menuItemExport.setText("Export CSV");
        menuItemExport.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItemExportActionPerformed(evt);
            }
        });
        jMenu1.add(menuItemExport);

        menuItemSave.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        menuItemSave.setText("Save");
        menuItemSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItemSaveActionPerformed(evt);
            }
        });
        jMenu1.add(menuItemSave);

        menuHlavniMenu.add(jMenu1);

        setJMenuBar(menuHlavniMenu);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(panelFilter, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(panelList, javax.swing.GroupLayout.PREFERRED_SIZE, 1036, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnSearch)
                    .addComponent(btnClear)
                    .addComponent(btnAdd)
                    .addComponent(btnEdit)
                    .addComponent(btnRemove))
                .addContainerGap(24, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {btnAdd, btnClear, btnEdit, btnRemove, btnSearch});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(panelFilter, javax.swing.GroupLayout.PREFERRED_SIZE, 159, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(panelList, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(54, 54, 54)
                        .addComponent(btnSearch)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnClear)
                        .addGap(123, 123, 123)
                        .addComponent(btnAdd)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnEdit)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnRemove)))
                .addContainerGap(45, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnSearchMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnSearchMouseClicked
  
  /*          ArrayList<String> params= new  ArrayList<String>();
         String name=txtJmeno.getText().trim();
         String funkce=txtFunkce.getText().trim();
         String telefon=txtTelefon.getText().trim();
         String mobil=txtMobil.getText().trim();
         String mail=txtEmail.getText().trim();
        
         String obor;
          try{
              obor=cmbOdbor.getSelectedItem().toString();
           } catch (Exception em) {
             obor=null;    
           }
  
          if(txtJmeno.getText().trim().length()==0&&
                 txtJmeno.getText().trim().length()==0&&
                 txtFunkce.getText().trim().length()==0&&
                 txtTelefon.getText().trim().length()==0&&
                 txtMobil.getText().trim().length()==0&&
                 txtEmail.getText().trim().length()==0&&
                 obor==null){
             txtJmeno.setText("WRONG INPUT!!! At least one parameter is needed!");

         }else {
              if(checkInput(name)){
                 if(checkInput(funkce)){
                     if(telefon.matches("[0-9]*")||"".equals(telefon)){
                          if(mobil.matches("[0-9]*")||"".equals(mobil)){
                               params.add(name);
                               params.add(funkce);
                               params.add(null);
                               params.add(null);
                               params.add(telefon);
                               params.add(mobil);
                               params.add(mail);
                               params.add(null);
                               params.add(obor);
                               params.add(null);
                               ArrayList<String[]> res = telSeznamController.getData(params, false, false);
                       
                               ShowResult(res);
                          }else{
                             txtMobil.setText("WRONG INPUT!!!");
                          }
                     }else{
                        txtTelefon.setText("WRONG INPUT!!!");
                     }
                 }else{
                    txtFunkce.setText("WRONG INPUT!!!");
                 }
              }else{
                    txtJmeno.setText("WRONG INPUT!!!");
              }
          }*/     
    }//GEN-LAST:event_btnSearchMouseClicked

    private void btnSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSearchActionPerformed
        ArrayList<String> params= new  ArrayList<String>();

        params.add(txtJmeno.getText());
        params.add(txtFunkce.getText());
        params.add(null);
        params.add(null);
        params.add(txtTelefon.getText());
        params.add(txtMobil.getText());
        params.add(txtEmail.getText());
        params.add(null);
        params.add(cmbOdbor.getSelectedItem()!=null ? cmbOdbor.getSelectedItem().toString() : null);
        params.add(null);

        ArrayList<String[]> res = telSeznamController.getData(params, chkCaseSensitive.isSelected(), chkDiacritics.isSelected());
        this.setTableModel(this.tabList, res); 
       
    }//GEN-LAST:event_btnSearchActionPerformed

    private void btnClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnClearActionPerformed

        this.setTableModel(this.tabList, telSeznamController.getData()); 
        txtJmeno.setText("");
        txtJmeno.setText("");
        txtFunkce.setText("");
        txtTelefon.setText("");
        txtMobil.setText("");
        txtEmail.setText("");
        cmbOdbor.setSelectedIndex(-1); 
    }//GEN-LAST:event_btnClearActionPerformed

    private void menuItemImportActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItemImportActionPerformed
        JFileChooser fileChooser = new JFileChooser("."); 

        fileChooser.setFileFilter(new FileNameExtensionFilter("CSV File", "csv"));

        int result = fileChooser.showOpenDialog(null);
        if (result == JFileChooser.APPROVE_OPTION) {
            File selectedFile = fileChooser.getSelectedFile();
            System.out.println(selectedFile.getName());
            System.out.println(selectedFile.getPath());
            telSeznamController.importCSV(selectedFile.getName());
            this.btnSearch.doClick();
            JOptionPane.showMessageDialog(null, "Soubor " + selectedFile.getName() + " byl importován.", "Info", JOptionPane.INFORMATION_MESSAGE);
        }
    }//GEN-LAST:event_menuItemImportActionPerformed

    private void menuItemExportActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItemExportActionPerformed
        JFileChooser fileChooser = new JFileChooser("."); 

        fileChooser.setFileFilter(new FileNameExtensionFilter("CSV File", "csv"));

        int result = fileChooser.showOpenDialog(null);
        if (result == JFileChooser.APPROVE_OPTION) {
            File selectedFile = fileChooser.getSelectedFile();
            System.out.println(selectedFile.getName());
            System.out.println(selectedFile.getPath());
            telSeznamController.exportCSV(selectedFile.getName());
            //this.btnSearch.doClick();
            JOptionPane.showMessageDialog(null, "Data byla exportována do souboru " + selectedFile.getName(), "Info", JOptionPane.INFORMATION_MESSAGE);
        }
    }//GEN-LAST:event_menuItemExportActionPerformed

    private void menuItemSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItemSaveActionPerformed
        try {
            telSeznamController.Serialize();
            JOptionPane.showMessageDialog(null, "Data byla uložena do souboru", "Info", JOptionPane.INFORMATION_MESSAGE);
        } catch (IOException ex) {
            Logger.getLogger(JFrameSearch.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(null, "Data nelze serializovat", "Chyba", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_menuItemSaveActionPerformed

    private void txtFunkceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtFunkceActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtFunkceActionPerformed

    private void txtMobilActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtMobilActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtMobilActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(JFrameSearch.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(JFrameSearch.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(JFrameSearch.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(JFrameSearch.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new JFrameSearch().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAdd;
    private javax.swing.JButton btnClear;
    private javax.swing.JButton btnEdit;
    private javax.swing.JButton btnRemove;
    private javax.swing.JButton btnSearch;
    private javax.swing.JCheckBox chkCaseSensitive;
    private javax.swing.JCheckBox chkDiacritics;
    private javax.swing.JComboBox<String> cmbOdbor;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lbEmail;
    private javax.swing.JLabel lbFunkce;
    private javax.swing.JLabel lbJmeno;
    private javax.swing.JLabel lbMobil;
    private javax.swing.JLabel lbOdbor;
    private javax.swing.JLabel lbTelefon;
    private javax.swing.JLabel lbTip;
    private javax.swing.JMenuBar menuHlavniMenu;
    private javax.swing.JMenuItem menuItemExport;
    private javax.swing.JMenuItem menuItemImport;
    private javax.swing.JMenuItem menuItemSave;
    private javax.swing.JPanel panelFilter;
    private javax.swing.JPanel panelList;
    private javax.swing.JTable tabList;
    private javax.swing.JTextField txtEmail;
    private javax.swing.JTextField txtFunkce;
    private javax.swing.JTextField txtJmeno;
    private javax.swing.JTextField txtMobil;
    private javax.swing.JTextField txtTelefon;
    // End of variables declaration//GEN-END:variables
}
